/*** 2SUP13.C ***/

extern unsigned _stklen = 10000;

#define float long double

#include "GRAFICOS.C"
#include "ESCONDID.C"

float f1(float u, float v) {
  if (u <= 6.28 && u > 3.14)
    return 6*cos(u)*(1 + sin(u)) + 4*(1 - cos(u)/2)*cos(v + M_PI);
  else
    return 6*cos(u)*(1 + sin(u)) + 4*(1 - cos(u)/2)*cos(v)*cos(u);
}
float f2(float u, float v) {
  if (u <= 6.28 && u > 3.14)
    return 16*sin(u);
  else
    return 16*sin(u) + 4*(1 - cos(u)/2)*sin(u)*cos(v);
}
float f3(float u, float v) { return 4*(1 - cos(u)/2)*sin(v); }

float g1(float x, float y) { return x; }
float g2(float x, float y) { return y; }
float g3(float x, float y) { return 1 - x/2 - y/2; }

int pontos_descartados = 0;
#define MAX_IT 100

#include "SIS.C"
#include "INTERS1.C"

char nome_arquivo[80] = "2SUP13";

void main(int argc) {

  int cor_f1_1 = BLACK, cor_f1_2 = BLACK,
      cor_f2_1 = BLACK, cor_f2_2 = BLACK,
      cor1_1 = RED, cor1_2 = CYAN,
      cor2_1 = BLACK, cor2_2 = BLACK,
      cor3_1 = RED, cor3_2 = CYAN,
      cor4_1 = BLACK, cor4_2 = BLACK,
      padrao1_1 = 255, padrao1_2 = 255,
      padrao2_1 = 255, padrao2_2 = 255,
      opcao = -1;
  float umin1 = 0, umax1 = 6.29, vmin1 = 0, vmax1 = 6.29,
	umin2 = -15, umax2 = 10, vmin2 = -15, vmax2 = 20;

  IniciaModoGrafico();
  o1 = 1.4; o2 = -2.6; o3 = -1.4;
  DeterminaPlanoDeProjecao();
  A = getmaxx()/4;
  B = getmaxy()/2;
  TAM = 15;
  nu = 40; nv = 40;
  Desenha2SuperficiesEsc(f1, f2, f3, umin1, umax1, vmin1, vmax1, cor_f1_1,
    cor_f2_1, cor1_1, cor2_1, cor3_1, cor4_1, padrao1_1, padrao2_1,
    g1, g2, g3, umin2, umax2, vmin2, vmax2, cor_f1_2, cor_f2_2, cor1_2,
    cor2_2, cor3_2, cor4_2, padrao1_2, padrao2_2, nome_arquivo, opcao);

  A = 3*getmaxx()/4;
  B = getmaxy()/2;
  nu = 25; nv = 25; inc = 0.01;
  setcolor(RED);
  DesenhaSuperficie2(f1, f2, f3, umin1, umax1, vmin1, vmax1);
  setcolor(BLUE);
  nu = 10; nv = 10;
  DesenhaSuperficie2(g1, g2, g3, umin2, umax2, vmin2, vmax2);
  setcolor(YELLOW);
  InterceptaSup2(f1, f2, f3, g1, g2, g3, umin1, umax1, vmin1, vmax1, 1, 1, 1);
  InterceptaSup2(f1, f2, f3, g1, g2, g3, umin2, umax2, vmin2, vmax2, -1, -1, -1);

  SalvaImagem(nome_arquivo);
  if (argc == 1) {
    getch();
    closegraph();
  }
}

/*** FIM DE 2SUP13.C ***/
